-- Talent check file for the hunter class
local class = "HUNTER";

-- set up check table
ScrubFork.checks = ScrubFork.checks or { };
ScrubFork.checks[class] = ScrubFork.checks[class] or { };

-- simple function to create new checks
local function check(name, severity, check)
	tinsert(ScrubFork.checks[class], {name=name, severity=severity, check=check});
end

local GREEN = ScrubFork.GREEN;
local YELLOW = ScrubFork.YELLOW;
local RED = ScrubFork.RED;

-- Meta
check("Partial Beast Mastery Spec",		YELLOW,	function (talents) return (talents:spent(1) >= 21) and (talents:spent(1) < 41); end);
check("No Raid Utility",				RED,	function (talents) return (talents:rank(1, 17) < 2) and (talents:rank(2, 17) < 1) and (talents:rank(3, 21) < 2); end);

-- Beast Mastery
check("Lacking Imp. Aspect of the Hawk",RED,	function (talents) return (talents:spent(1) >= 5) and (talents:rank(1,  1) < 5); end);
check("Lacking Focused Fire",			RED,	function (talents) return (talents:spent(1) >= 7) and (talents:rank(1,  3) < 2); end);
check("Imp. Aspect of the Monkey (PvP)",RED,	function (talents) return talents:rank(1,  4) > 0; end);
check("Pathfinding",					RED,	function (talents) return talents:rank(1,  7) > 0; end);
check("Lacking Unleashed Fury",			RED,	function (talents) return (talents:spent(1) >= 16) and (talents:rank(1,  9) < 5); end);
check("Lacking Ferocity",				RED,	function (talents) return (talents:spent(1) >= 20) and (talents:rank(1, 11) < 5); end);
check("Spirit Bond",					YELLOW,	function (talents) return talents:rank(1, 12) > 0; end);
check("No Intimidation",				RED,	function (talents) return (talents:spent(1) >= 21) and (talents:rank(1, 13) < 1); end);
check("Lacking Bestial Discipline",		YELLOW,	function (talents) return (talents:spent(1) >= 23) and (talents:rank(1, 14) < 2); end);
check("Lacking Frenzy",					RED,	function (talents) return (talents:spent(1) >= 30) and (talents:rank(1, 16) < 4); end);
check("Lacking Ferocious Inspiration",	YELLOW,	function (talents) return (talents:spent(1) >= 34) and (talents:rank(1, 17) < 3); end);
check("FI without Animal Handler",		YELLOW,	function (talents) return (talents:rank(1, 17) > 0) and (talents:rank(1, 15) < 2); end);
check("No Bestial Wrath",				RED,	function (talents) return (talents:spent(1) >= 31) and (talents:rank(1, 18) < 1); end);
check("Lacking Serpent's Swiftness",	RED,	function (talents) return (talents:spent(1) >= 40) and (talents:rank(1, 20) < 5); end);
check("No Beast Within",				RED,	function (talents) return (talents:spent(1) >= 41) and (talents:rank(1, 21) < 1); end);

-- Marksmanship
check("Improved Concussive Shot (PvP)",	YELLOW,	function (talents) return talents:rank(2,  1) > 0; end);
check("Lacking Lethal Shots",			RED,	function (talents) return talents:rank(2,  2) < 5; end);
check("Lacking IHM or Efficiency",		RED,	function (talents) return (talents:spent(2) >= 10) and (talents:rank(2,  3) < 5) and (talents:rank(2, 4) < 5); end);
check("Lacking Go for the Throat",		YELLOW,	function (talents) return (talents:spent(1) >= 10) and (talents:spent(2) >= 13) and (talents:rank(2,  5) < 2); end);
check("No Aimed Shot",					RED,	function (talents) return (talents:spent(2) >= 11) and (talents:rank(2,  7) < 1); end);
check("Lacking Mortal Shots",			RED,	function (talents) return talents:rank(2, 10) < 5; end);
check("Concussive Barrage (PvP)",		RED,	function (talents) return talents:rank(2, 11) > 0; end);
check("Lacking Combat Experience",		YELLOW,	function (talents) return (talents:spent(2) >= 33) and (talents:rank(2, 14) < 2); end);
check("Lacking Ranged Weapon Spec.",	RED,	function (talents) return (talents:spent(2) >= 30) and (talents:rank(2, 15) < 5); end);
check("Lacking Careful Aim",			RED,	function (talents) return (talents:spent(2) >= 36) and (talents:rank(2, 16) < 3); end);
check("No Trueshot Aura",				RED,	function (talents) return (talents:spent(2) >= 31) and (talents:rank(2, 17) < 1); end);
check("Lacking Master Marksman",		RED,	function (talents) return (talents:spent(2) >= 40) and (talents:rank(2, 19) < 5); end);
check("Silencing Shot (PvP)",			YELLOW,	function (talents) return talents:rank(2, 20) > 0; end);

-- Survival
check("Lacking Hawk Eye",				RED,	function (talents) return (talents:spent(3) >=  3) and (talents:rank(3,  3) < 2); end);
check("Savage Strikes",					RED,	function (talents) return talents:rank(3,  4) > 0; end);
check("Deflection (PvP)",				RED,	function (talents) return talents:rank(3,  6) > 0; end);
check("Improved Wing Clip (PvP)",		YELLOW,	function (talents) return talents:rank(3,  7) > 1; end);
check("Deterrence (PvP)",				YELLOW,	function (talents) return talents:rank(3, 10) > 0; end);
check("Excessive Trap Mastery",			YELLOW,	function (talents) return talents:rank(3, 11) > 1; end);
check("Lacking Surefooted",				RED,	function (talents) return (talents:spent(3) >= 16) and (talents:rank(3, 12) < 3); end);
check("Lacking Survival Instincts",		RED,	function (talents) return (talents:spent(3) >= 25) and (talents:rank(3, 14) < 2); end);
check("Lacking Killer Instinct",		RED,	function (talents) return (talents:spent(3) >= 23) and (talents:rank(3, 15) < 3); end);
check("Counterattack (PvP)",			RED,	function (talents) return talents:rank(3, 16) > 0; end);
check("Lacking Lightning Reflexes",		RED,	function (talents) return (talents:spent(3) >= 30) and (talents:rank(3, 18) < 5); end);
check("Lacking Thrill of the Hunt",		YELLOW,	function (talents) return (talents:spent(3) >= 36) and (talents:rank(3, 19) < 2); end);
check("Wyvern Sting (PvP)",				YELLOW,	function (talents) return talents:rank(3, 20) > 0; end);
check("Lacking Expose Weakness",		RED,	function (talents) return (talents:spent(3) >= 33) and (talents:rank(3, 21) < 3); end);
check("No Readiness",					YELLOW,	function (talents) return (talents:spent(3) >= 41) and (talents:rank(3, 23) < 1); end);
