-- Talent check file for the paladin class
local class = "PALADIN";

-- set up check table
ScrubFork.checks = ScrubFork.checks or { };
ScrubFork.checks[class] = ScrubFork.checks[class] or { };

-- simple function to create new checks
local function check(name, severity, check)
	tinsert(ScrubFork.checks[class], {name=name, severity=severity, check=check});
end

local GREEN = ScrubFork.GREEN;
local YELLOW = ScrubFork.YELLOW;
local RED = ScrubFork.RED;

-- Meta
check("Partial Retribution Spec",		RED,	function (talents) return (talents:spent(3) >= 21) and (talents:spent(3) < 41); end);

-- Holy
check("Divine Strength",				YELLOW, function (talents) return (talents:spent(3) <  41) and (talents:rank(1,  1) > 0); end);
check("Lacking Spiritual Focus",		YELLOW,	function (talents) return (talents:spent(1) >= 10) and (talents:rank(1,  3) < 5); end);
check("Improved Seal of Righteousness",	RED,	function (talents) return talents:rank(1,  4) > 0; end);
check("Lacking Healing Light",			RED,	function (talents) return (talents:spent(1) >= 15) and (talents:rank(1,  5) < 3); end);
check("No Aura Mastery",				YELLOW,	function (talents) return (talents:spent(1) >= 11) and (talents:rank(1,  6) < 1); end);
check("Lacking Imp. Lay on Hands",		YELLOW,	function (talents) return (talents:spent(1) >= 15) and (talents:rank(1,  7) < 2); end);
check("Lacking Illumination",			RED,	function (talents) return (talents:spent(1) >= 20) and (talents:rank(1,  9) < 5); end);
check("No Divine Favor",				RED,	function (talents) return (talents:spent(1) >= 21) and (talents:rank(1, 12) < 1); end);
check("Lacking Sanctified Light",		RED,	function (talents) return (talents:spent(1) >= 24) and (talents:rank(1, 13) < 3); end);
check("Lacking Holy Power",				RED,	function (talents) return (talents:spent(1) >= 30) and (talents:rank(1, 15) < 5); end);
check("Lacking Light's Grace",			RED,	function (talents) return (talents:spent(1) >= 34) and (talents:rank(1, 16) < 3); end);
check("No Holy Shock",					RED,	function (talents) return (talents:spent(1) >= 31) and (talents:rank(1, 17) < 1); end);
check("Lacking Holy Guidance",			YELLOW,	function (talents) return (talents:spent(1) >= 40) and (talents:rank(1, 19) < 5); end);
check("No Divine Illumination",			RED,	function (talents) return (talents:spent(1) >= 41) and (talents:rank(1, 20) < 1); end);

-- Protection
check("Lacking Redoubt",				RED,	function (talents) return (talents:spent(2) >= 25) and (talents:rank(2,  2) < 5); end);
check("Redoubt (PvP)",					YELLOW,	function (talents) return (talents:spent(1) >= 25) and (talents:rank(2,  2) > 0); end);
check("Lacking Precision",				RED,	function (talents) return (talents:spent(1) <  25) and (talents:rank(2,  3) < 3); end);
check("Lacking Toughness",				RED,	function (talents) return (talents:spent(2) >= 25) and (talents:rank(2,  5) < 5); end);
check("Toughness (PvP)",				YELLOW,	function (talents) return (talents:spent(1) >= 25) and (talents:rank(2,  5) > 3); end);
check("No Blessing of Kings",			YELLOW,	function (talents) return (talents:spent(2) >= 11) and (talents:rank(2,  6) < 1); end);
check("Lacking Imp. Righteous Fury",	RED,	function (talents) return (talents:spent(2) >= 25) and (talents:rank(2,  7) < 3); end);
check("Lacking Spell Warding",			YELLOW,	function (talents) return (talents:spent(2) >= 23) and (talents:rank(2, 13) < 2); end);
check("No Blessing of Sanctuary",		RED,	function (talents) return (talents:spent(2) >= 21) and (talents:rank(2, 14) < 1); end);
check("No Holy Shield",					RED,	function (talents) return (talents:spent(2) >= 31) and (talents:rank(2, 19) < 1); end);
check("Lacking Improved Holy Shield",	RED,	function (talents) return (talents:spent(2) >= 33) and (talents:rank(2, 18) < 2); end);
check("Lacking Ardent Defender",		YELLOW,	function (talents) return (talents:spent(2) >= 46) and (talents:rank(2, 20) < 5); end);
check("Lacking Combat Expertise",		RED,	function (talents) return (talents:spent(2) >= 40) and (talents:rank(2, 21) < 5); end);
check("No Avenger's Shield",			RED,	function (talents) return (talents:spent(2) >= 41) and (talents:rank(2, 22) < 1); end);

-- Retribution
check("Lacking Benediction",			YELLOW,	function (talents) return (talents:spent(3) >= 25) and (talents:rank(3,  2) < 5); end);
check("Lacking Improved Judgement",		RED,	function (talents) return (talents:spent(3) >= 10) and (talents:spent(2) < 25) and (talents:rank(3,  3) < 2); end);
check("Lacking Imp. Seal of Crusader",	RED,	function (talents) return (talents:spent(3) >= 10) and (talents:spent(2) < 25) and (talents:rank(3,  4) < 3); end);
check("Lacking Deflection",				YELLOW,	function (talents) return (talents:spent(2) >= 25) and (talents:rank(3,  5) < 5); end);
check("Deflection",						YELLOW,	function (talents) return (talents:spent(2) <  25) and (talents:rank(3,  5) > 0); end);
check("Vindication",					RED,	function (talents) return talents:rank(3,  6) > 0; end);
check("Lacking Conviction",				RED,	function (talents) return (talents:spent(3) >= 16) and (talents:rank(3,  7) < 5); end);
check("No Seal of Command",				RED,	function (talents) return (talents:spent(3) >= 20) and (talents:rank(3,  8) < 1); end);
check("Eye for an Eye (PvP)",			YELLOW,	function (talents) return talents:rank(3, 10) > 0; end);
check("Lacking Crusade",				YELLOW,	function (talents) return (talents:spent(3) >= 20) and (talents:rank(3, 12) < 3); end);
check("Lacking 2H Weapon Spec.",		RED,	function (talents) return (talents:spent(3) >= 25) and (talents:rank(3, 13) < 3); end);
check("No Sanctity Aura",				RED,	function (talents) return (talents:spent(3) >= 21) and (talents:rank(3, 14) < 1); end);
check("Lacking Imp. Sanctity Aura",		RED,	function (talents) return (talents:spent(3) >= 25) and (talents:rank(3, 15) < 2); end);
check("Lacking Vengeance",				RED,	function (talents) return (talents:spent(3) >= 30) and (talents:rank(3, 16) < 5); end);
check("Lacking Sanctified Judgement",	YELLOW,	function (talents) return (talents:spent(3) >= 44) and (talents:rank(3, 17) < 3); end);
check("Lacking Sanctified Seals",		YELLOW,	function (talents) return (talents:spent(3) >= 35) and (talents:rank(3, 18) < 3); end);
check("No Repentance",					RED,	function (talents) return (talents:spent(3) >= 31) and (talents:rank(3, 19) < 1); end);
check("Divine Purpose (PvP)",			YELLOW,	function (talents) return talents:rank(3, 20) > 0; end);
check("Lacking Fanaticism",				RED,	function (talents) return (talents:spent(3) >= 40) and (talents:rank(3, 21) < 5); end);
check("No Crusader Strike",				RED,	function (talents) return (talents:spent(3) >= 41) and (talents:rank(3, 22) < 1); end);
