-- Talent check file for the warlock class
local class = "WARLOCK";

-- set up check table
ScrubFork.checks = ScrubFork.checks or { };
ScrubFork.checks[class] = ScrubFork.checks[class] or { };

-- simple function to create new checks
local function check(name, severity, check)
	tinsert(ScrubFork.checks[class], {name=name, severity=severity, check=check});
end

local GREEN = ScrubFork.GREEN;
local YELLOW = ScrubFork.YELLOW;
local RED = ScrubFork.RED;

-- Meta
check("Partial Affliction Spec",		RED,	function (talents) return (talents:spent(1) >= 21) and (talents:spent(1) < 40); end);
check("Partial Demonology Spec",		RED,	function (talents) return (talents:spent(2) >= 22) and (talents:spent(2) < 41); end);
check("Partial Destruction Spec",		RED,	function (talents) return (talents:spent(3) >= 21) and (talents:spent(3) < 40); end);
check("Demonology Filler Talents",		RED,	function (talents) return (talents:spent(2) <= 21) and (
													talents:rank(2, 1) + talents:rank(2, 2) +
													talents:rank(2, 4) + talents:rank(2, 5) +
													talents:rank(2, 7) > 3); end);

-- Affliction
check("Lacking Improved Corruption",	RED,	function (talents) return (talents:spent(1) >=  4) and (talents:rank(1,  2) < 4); end);
check("Improved Curse of Weakness",		RED,	function (talents) return talents:rank(1,  3) > 0; end);
check("Lacking Improved Drain Soul",	RED,	function (talents) return (talents:spent(1) >= 10) and (talents:rank(1,  4) < 2); end);
check("Lacking Improved Life Tap",		RED,	function (talents) return (talents:spent(1) >=  7) and (talents:rank(1,  5) < 2); end);
check("Lacking Shadow Embrace",			YELLOW,	function (talents) return (talents:spent(1) >= 42) and (talents:rank(1, 13) < 5); end);
check("No Siphon Life",					RED,	function (talents) return (talents:spent(1) >= 21) and (talents:rank(1, 14) < 1); end);
check("Lacking Shadow Mastery",			RED,	function (talents) return (talents:spent(1) >= 25) and (talents:rank(1, 16) < 5); end);
check("No Dark Pact",					RED,	function (talents) return (talents:spent(1) >= 31) and (talents:rank(1, 18) < 1); end);
check("Lacking Malediction",			YELLOW,	function (talents) return (talents:spent(1) >= 38) and (talents:rank(1, 20) < 3); end);
check("No Unstable Affliction",			YELLOW,	function (talents) return (talents:spent(1) >= 41) and (talents:rank(1, 21) < 1); end);

-- Demonology
check("Lacking Demonic Embrace",		YELLOW,	function (talents) return (talents:spent(2) >=  8) and (talents:rank(2,  3) < 5); end);
check("No Fel Domination",				RED,	function (talents) return (talents:spent(2) >= 11) and (talents:rank(2,  8) < 1); end);
check("Lacking Demonic Aegis",			YELLOW,	function (talents) return (talents:spent(2) >= 14) and (talents:rank(2, 10) < 3); end);
check("Lacking Master Summoner",		YELLOW,	function (talents) return (talents:spent(2) >= 17) and (talents:rank(2, 11) < 2); end);
check("Unholy Power without Felguard",	RED,	function (talents) return (talents:rank(2, 12) > 0) and (talents:rank(2, 22) < 1); end);
check("Improved Enslave Demon",			RED,	function (talents) return talents:rank(2, 13) > 0; end);
check("No Demonic Sacrifice",			RED,	function (talents) return (talents:spent(2) >= 21) and (talents:rank(2, 14) < 1); end);
check("Master Conjurer",				RED,	function (talents) return talents:rank(2, 15) > 0; end);
check("2+ Mana Feed",					YELLOW,	function (talents) return talents:rank(2, 16) > 1; end);
check("Lacking Master Demonologist",	RED,	function (talents) return (talents:spent(2) >= 30) and (talents:rank(2, 17) < 5); end);
check("No Soul Link",					RED,	function (talents) return (talents:spent(2) >= 31) and (talents:rank(2, 19) < 1); end);
check("Lacking Demonic Knowledge",		RED,	function (talents) return (talents:spent(2) >= 35) and (talents:rank(2, 20) < 3); end);
check("Lacking Demonic Tactics",		YELLOW,	function (talents) return (talents:spent(2) >= 40) and (talents:rank(2, 21) < 5); end);
check("No Summon Felguard",				RED,	function (talents) return (talents:spent(2) >= 41) and (talents:rank(2, 22) < 1); end);

-- Destruction
check("Lacking Improved Shadow Bolt",	RED,	function (talents) return talents:rank(3,  1) < 5; end);
check("Lacking Bane",					RED,	function (talents) return talents:rank(3,  3) < 5; end);
check("Aftermath (PvP)",				RED,	function (talents) return talents:rank(3,  4) > 0; end);
check("Improved Firebolt",				RED,	function (talents) return talents:rank(3,  5) > 0; end);
check("Improved Lash of Pain",			RED,	function (talents) return talents:rank(3,  6) > 0; end);
check("Lacking Devastation",			RED,	function (talents) return (talents:spent(3) >= 15) and (talents:rank(3,  7) < 4); end);
check("No Shadowburn",					YELLOW,	function (talents) return (talents:spent(3) >= 11) and (talents:rank(3,  8) < 1); end);
check("Lacking Intensity",				YELLOW,	function (talents) return (talents:spent(3) >= 20) and (talents:rank(3,  9) < 2); end);
check("Lacking Destructive Reach",		RED,	function (talents) return (talents:spent(3) >= 20) and (talents:rank(3, 10) < 2); end);
check("Improved Searing Pain (PvP)",	YELLOW,	function (talents) return talents:rank(3, 11) > 1; end);
check("Pyroclasm",						RED,	function (talents) return talents:rank(3, 12) > 0; end);
check("Imp. Immolate without Conflag",	YELLOW,	function (talents) return (talents:spent(3) >= 31) and (talents:rank(3, 13) == 5) and (talents:rank(3, 18) < 1); end);
check("No Ruin",						RED,	function (talents) return (talents:spent(3) >= 21) and (talents:rank(3, 14) < 1); end);
check("Lacking Shadow and Flame",		RED,	function (talents) return (talents:spent(3) >= 40) and (talents:rank(3, 20) < 5); end);
check("Shadowfury (PvP)",				YELLOW,	function (talents) return talents:rank(3, 21) > 0; end);
